#!/bin/bash
set -m

AUTORUN_MAPPING_DIR="/var/lib/dcv-session-manager-agent/var/autorun-mapping"

_session_id="${DCV_SESSION_ID}"
_mapping_file="${AUTORUN_MAPPING_DIR}/${_session_id}.map"
_mapping_expanded=$(LANG=C.UTF-8 sed 's/"/\\\"/g;s/.*/echo "&"/e' "${_mapping_file}")
_cmd_lines=()
while LANG=C.UTF-8 IFS= read -r _line || [[ -n "${_line}" ]]; do
   _cmd_lines+=("${_line}")
done < <(LANG=C.UTF-8 echo "${_mapping_expanded}")

if [ ${#_cmd_lines[@]} -ge 2 ]; then
    _init_file="${_cmd_lines[0]}"
    unset "_cmd_lines[0]"

    "${_init_file}" &
    echo "Executing program set for autorun ${_cmd_lines[*]}"
    "${_cmd_lines[@]}" &
    fg %1
else
    echo "Invalid mapping file ${_mapping_file}"
fi
